
#include <Y/y.h>
#include <Y/modules/windowmanager_interface.h>
#include <Y/modules/windowmanager.h>
#include <Y/util/yutil.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <dlfcn.h>

static struct WindowManager *currentWindowManager = NULL;

void
windowmanagerRegister (struct WindowManager *wm)
{
  if (currentWindowManager != NULL)
    currentWindowManager -> unload (currentWindowManager);
  currentWindowManager = wm; 
}

void
wmRegisterWindow (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> registerWindow (currentWindowManager, w);
}

void
wmUnregisterWindow (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> unregisterWindow (currentWindowManager, w);
}

void
wmKeyboard (int key, int pressed, int modifiers)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> keyboard (currentWindowManager, key, pressed, modifiers);
}

void
wmWindowPointerButton (struct Window *w, int x, int y, int b, int pressed)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> windowPointerButton (currentWindowManager, w,
                                               x, y, b, pressed);
}

void
wmWindowPointerMotion (struct Window *w, int x, int y, int dx, int dy)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> windowPointerMotion (currentWindowManager, w,
                                               x, y, dx, dy);
}

void
wmWindowPointerEnter (struct Window *w, int x, int y)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> windowPointerEnter (currentWindowManager, w, x, y);
}

void
wmWindowPointerLeave (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  currentWindowManager -> windowPointerLeave (currentWindowManager, w);
}

struct Window *
wmSelectedWindow ()
{
  if (currentWindowManager == NULL)
    return NULL;
  return currentWindowManager -> selectedWindow (currentWindowManager);
}

void
wmSelectWindow (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  return currentWindowManager -> selectWindow (currentWindowManager, w);
}

void
wmMaximiseWindow (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  return currentWindowManager -> maximiseWindow (currentWindowManager, w);
}

void
wmRestoreWindow (struct Window *w)
{
  if (currentWindowManager == NULL)
    return;
  return currentWindowManager -> restoreWindow (currentWindowManager, w);
}

/* arch-tag: 07b8bf39-884b-49a3-a3e6-1769c44432a2
 */
