
#ifndef Y_OBJECT_OBJECT_H
#define Y_OBJECT_OBJECT_H

struct Object;

#include <Y/y.h>
#include <Y/object/property.h>
#include <Y/object/parameters.h>
#include <Y/message/client.h>

typedef void (*ObjectMethod_t)(struct Object *, struct Parameters *);

int           objectGetID (struct Object *);
struct Class *objectClass (struct Object *);

struct Object *objectFind (int oid);

/* for putting objects in indices */
int objectComparisonFunction (void *, void *);
int objectKeyFunction (void *, void *);

const char * objectGetPropertyAsString  (struct Object *, const char *);
int          objectGetPropertyAsInteger (struct Object *, const char *);
int          objectIsPropertySet        (struct Object *, const char *);
void         objectClearProperty        (struct Object *, const char *);
void         objectSetPropertyToString  (struct Object *, const char *, 
                                         const char *);
void         objectSetPropertyToInteger (struct Object *, const char *, int);
void         objectPropertyCallOnSet (struct Object *, const char *, void *,
                                      PropertyCallback_t);

void         objectInvokeMethod (struct Object *, const char *,
                                 struct Parameters *);

void         objectEmitSignal (struct Object *, const char *,
                               struct Parameters *);
void         objectSubscribeSignal (struct Object *, const char *);

void         objectDestroy (struct Object *);

#endif


/* arch-tag: 0fed6be1-efef-42f0-9cc8-e016a4fd181f
 */
