
#ifndef Y_OBJECT_PARAMETERS_H
#define Y_OBJECT_PARAMETERS_H

struct Parameters;

#include <Y/y.h>

struct Parameters *parametersCreate ();
struct Parameters *parametersBuild (char *data, int len);
void               parametersDestroy (struct Parameters *);

/* Creates a duplicate Parameters object. This object is
 * subordinate to the original, in that the original may
 * not be destroyed until after the duplicate.
 */
struct Parameters *parametersDuplicate (struct Parameters *);

void        parametersAddInput (struct Parameters *, const char *string);
void        parametersAddInputInteger (struct Parameters *, int value);
int         parametersGetInputCount (struct Parameters *);
const char *parametersGetInput (struct Parameters *, int);
void        parametersShiftInput (struct Parameters *, int);

void        parametersAddOutput (struct Parameters *, const char *string);
void        parametersAddOutputInteger (struct Parameters *, int value);
int         parametersGetOutputCount (struct Parameters *);
const char *parametersGetOutput (struct Parameters *, int);
char *      parametersGetOutputData (struct Parameters *, const char *prefix,
                                     int *len_p);

void        parametersFreeOnDestroy (struct Parameters *, char *);

void        parametersSetError (struct Parameters *);
void        parametersClearError (struct Parameters *);
int         parametersIsError (struct Parameters *);

#endif

/* arch-tag: 402c741b-1a46-44b6-8093-799373445298
 */
