/* screen.h */

#ifndef Y_SCREEN_SCREEN_H
#define Y_SCREEN_SCREEN_H

#include <Y/screen/viewport.h>
#include <Y/util/rectangle.h>
#include <Y/widget/widget.h>

/* There is only one screen, so it is not an object */

void           screenInitialise ();
void           screenFinalise ();

void           screenRegisterViewport  (struct Viewport *);
void           screenUnregisterViewport(struct Viewport *);

void           screenConstrainPoint (int *, int *);

void           screenSetRootWidget (struct Widget *);
struct Widget *screenGetRootWidget ();

void           screenInvalidateRectangle (struct Rectangle *);

void           screenViewportsChanged ();

void           screenUpdate ();
void           screenRender (struct Renderer *);

#endif

/* arch-tag: 1470f2f8-59eb-4322-9bf9-23580571acab
 */
