
#define CHECK_STOP abort()
#include <Y/util/check.h>

#include <Y/util/pqueue.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

char *checkName;
char *checkModule;

#define FUNCTIONALITY_NUM_CHECK 100

struct pqueue_check_Functionality
{
  long int priority;
  int checkCode;
};

static int
pqueue_check_functionality_comparisonFunction (void *obj1_v, void *obj2_v)
{
  struct pqueue_check_Functionality *obj1 = obj1_v;
  struct pqueue_check_Functionality *obj2 = obj2_v;
  return obj1 -> priority - obj2 -> priority;
}

static char pqueue_check_functionality_usage[FUNCTIONALITY_NUM_CHECK];

static void
pqueue_check_functionality_destructorFunction (void *obj_v)
{
  struct pqueue_check_Functionality *obj = obj_v;
  pqueue_check_functionality_usage[obj -> checkCode]++;
  free (obj);
}

int
pqueue_check_functionality ()
{
  struct PQueue *pqueue;
  struct pqueue_check_Functionality *objs[FUNCTIONALITY_NUM_CHECK];
  struct pqueue_check_Functionality *obj;
  int i;

  checkModule = "functionality";

  srandom (time (NULL));

  pqueue = pqueueCreate (pqueue_check_functionality_comparisonFunction);

  CHECK_THAT ( pqueue != NULL );

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      objs[i] = malloc (sizeof (struct pqueue_check_Functionality));
      objs[i] -> priority = random ();
      objs[i] -> checkCode = i;
      pqueue_check_functionality_usage[i] = 0;
      pqueueInsert (pqueue, objs[i]);
    }

  i = 0;
  while ((obj = pqueueGetNext (pqueue)) != NULL)
    {
      CHECK_THAT ( i <= obj -> priority );
      pqueue_check_functionality_usage[obj -> checkCode]++;
      i = obj -> priority;
    } 

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      CHECK_THAT ( pqueue_check_functionality_usage[i] == 1 );
    }
  
  for (i=FUNCTIONALITY_NUM_CHECK-1; i>=0; --i)
    {
      pqueueInsert (pqueue, objs[i]);
    }

  pqueueDestroy (pqueue, pqueue_check_functionality_destructorFunction);

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      CHECK_THAT ( pqueue_check_functionality_usage[i] == 2 );
    }

  return 0;
    
}


int
main (int argc, char **argv)
{
  int failed = 0;
  checkName = "PQueue";
  failed = pqueue_check_functionality () ? 1 : failed;
  return failed;
}

/* arch-tag: 03de760f-7201-47d9-ab18-298fc1ac2dba
 */
