/* zorder.h */

#ifndef Y_UTIL_ZORDER_H
#define Y_UTIL_ZORDER_H

struct ZOrder;
struct ZOrderIterator;

#include <Y/y.h>

struct ZOrder *zorderCreate    (int (*keyFunction)(void *, void *),
                                int (*comparisonFunction)(void *, void *));
void           zorderDestroy   (struct ZOrder *,
                                void (*destructorFunction)(void *));

void           zorderAddAtTop            (struct ZOrder *, void *);
void           zorderRemove              (struct ZOrder *, void *);
void           zorderMoveToTop           (struct ZOrder *, void *);
void           zorderMoveUp              (struct ZOrder *, void *);
void           zorderMoveDown            (struct ZOrder *, void *);
void           zorderMoveToBottom        (struct ZOrder *, void *);
void *         zorderGetTop              (struct ZOrder *);
void *         zorderGetBottom           (struct ZOrder *);

struct ZOrderIterator *zorderGetTopIterator (struct ZOrder *);
struct ZOrderIterator *zorderGetBottomIterator (struct ZOrder *);

void           zorderiteratorDestroy   (struct ZOrderIterator *);
int            zorderiteratorHasValue  (struct ZOrderIterator *);
void *         zorderiteratorGet       (struct ZOrderIterator *);
void           zorderiteratorMoveUp    (struct ZOrderIterator *);
void           zorderiteratorMoveDown  (struct ZOrderIterator *);

#endif

/* arch-tag: 97afbc1e-f573-4938-965c-32f8cb4ba4d7
 */
