
#ifndef Y_WIDGET_WIDGET_P_H
#define Y_WIDGET_WIDGET_P_H

#include <Y/widget/widget.h>
#include <Y/object/class.h>
#include <Y/object/object_p.h>

struct WidgetTable
{
  struct Class *c;

  int             (*containsPoint)(const struct Widget *, int, int);

  struct Window * (*getWindow)    (struct Widget *);

  void            (*unpack)       (struct Widget *, struct Widget *);

  void            (*render)       (struct Widget *, struct Renderer *);
  void            (*paint)        (struct Widget *, struct Painter *);
  void            (*repaint)      (struct Widget *, struct Rectangle *);

  void            (*reconfigure)  (struct Widget *);
  void            (*resize)       (struct Widget *);

  int             (*pointerMotion)(struct Widget *, int, int, int, int);
  int             (*pointerButton)(struct Widget *, int, int, int, int);
  void            (*pointerEnter) (struct Widget *, int, int);
  void            (*pointerLeave) (struct Widget *);
  int             (*keyboardRaw)  (struct Widget *, enum YKeyCode, int, int);

};

struct Widget
{
  struct Object o;
  struct Object *parent;
  struct Widget *container;
  struct WidgetTable *tab;
  enum WidgetState state;
  int x, y, w, h;
  int minWidth, minHeight;
  int reqWidth, reqHeight;
  int maxWidth, maxHeight;
};

extern struct Class widgetClass;

void widgetInitialise (struct Widget *, struct WidgetTable *);
void widgetFinalise (struct Widget *);

#endif /* header guard */

/* arch-tag: 2b199ef4-f9f1-4bbb-9323-d2b014b96f27
 */
