#ifndef YCALCULATOR_CALCULATOR_H
#define YCALCULATOR_CALCULATOR_H

#include <Y/c++.h>
#include <sigc++/signal_system.h>

#include <stack>

using namespace SigC;
using namespace std;

class Calculator : public SigC::Object
{
  private:
    Y::Window *window;
    Y::Label *result;

    enum Operator
      {
        PLUS, MINUS, DIVIDE, MULTIPLY, EQUALS
      };

    stack<double> operands;
    stack<Operator> operators;

    double current;
    int decimalPlace;

    void setResult (double v);
    bool operatorLessThan (Operator, Operator);
    void evaluate (Operator max);

  public:
    Calculator ();
    virtual ~Calculator ();

    void numberClicked (int n);
    void pointClicked ();
    void clearClicked ();
    void operatorClicked (Operator op);
    void equalsClicked ();

};

#endif

/* arch-tag: 0062c097-9f61-4126-8147-8701cd192e10
 */
