#ifndef Y_CPP_CONSOLE_H
#define Y_CPP_CONSOLE_H

#include <Y/c++/widget.h>
#include <stdint.h>
#include <sigc++/signal_system.h>

#include <Y/const.h>

namespace Y
{
  class Console : public Widget
  {
    public:
      Console ();
      virtual ~Console ();

      void drawText (int col, int row, const string &mbstring,
                     int length, int width);
      void clearRect (int sCol, int sRow, int eCol, int eRow);
      void setRendition (int bold, int blink, int inverse, int underline,
                         int foreground, int background, char charset);
      void swapVideo ();
      void ring ();
      void updateCursorPos (int col, int row);
      void scrollView (int destRow, int srcRow, int numLine);

      SigC::Signal2<void, enum YKeyCode, unsigned int> keyPress;
      SigC::Signal2<void, int, int> resize;

    protected:
      virtual void onEvent (const string &, const vector<string> &);

    private:
      static int consoleClassId;
  };
}

#endif

/* arch-tag: 9fe8ff4e-fe53-487d-859b-a49549236937
 */
